/************************************************************
 **
 ** jal_vdef.h : JAL variable parsing declarations
 **
 ** Copyright (c) 2004-2005, Kyle A. York
 ** All rights reserved
 **
 ************************************************************/
#ifndef jal_vdef_h__
#define jal_vdef_h__

#include "../libcore/pfile.h"

void jal_parse_var_common(pfile_t *pf, variable_t *dst, flag_t flags);
void jal_parse_var(pfile_t *pf);
void jal_parse_const(pfile_t *pf);
variable_def_t jal_vdef_get(pfile_t *pf, flag_t flags);

typedef struct {
  char          *name;
  variable_t     master;
  unsigned       base[VARIABLE_MIRROR_CT];
  size_t         base_ct;
  unsigned       bit;
  unsigned       ct;        /* for arrays, -1 = undetermined size */
  flag_t         var_flags; /* variable specific flags */
  flag_t         def_flags;
  variable_def_t vdef;
} jal_variable_info_t;

void jal_variable_info_init(jal_variable_info_t *inf);
variable_t jal_variable_alloc(pfile_t *pf, 
  const jal_variable_info_t *inf, boolean_t is_param,
  size_t init_ct, value_t *init, pfile_variable_alloc_t where);

#endif /* jal_vdef_h__ */

