/************************************************************
 **
 ** pic_op.h : PIC operator generation declarations
 **
 ** Copyright (c) 2004-2005, Kyle A. York
 ** All rights reserved
 **
 ************************************************************/
#ifndef pic_op_h__
#define pic_op_h__

#include "pic.h"

typedef enum {
  PIC_INDIRECT_CHANGE_NONE,
  PIC_INDIRECT_CHANGE_INCR,
  PIC_INDIRECT_CHANGE_DECR
} pic_indirect_change_t;


/* operator --> pic instructions */
void pic_op(pfile_t *pf, operator_t op, value_t dst, value_t val1,
    value_t val2);
void pic_indirect_setup(pfile_t *pf, value_t val, size_t offset);
void pic_set_to_w(pfile_t *pf, value_t dst);

void pic_last_values_reset(void);

operator_t pic_op_relational2(pfile_t *pf, operator_t op, value_t dst, 
    value_t val1, value_t val2);

void pic_value_to_w(pfile_t *pf, value_t src, unsigned ofs,
    pic_indirect_change_t change);
#endif /* pic_op_h__ */

